// 004 u_gof_composite
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_gof_composite;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    create_pc_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_pc_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_log, u_c_display
        , u_dir, u_file

        , u_c_equipment_8
        , u_c_equipment_kinds_8
    ;

    {$R *.DFM}

 
    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.create_pc_Click(Sender: TObject);
      var l_c_cabinet: c_cabinet;
          l_c_chassis: c_chassis;
          l_c_bus: c_bus;
      begin
        l_c_cabinet:= c_cabinet.create_cabinet('cabinet');
        l_c_chassis:= c_chassis.create_chassis('chassis');

        l_c_cabinet.add_equipment(l_c_chassis);

        l_c_bus:= c_bus.create_bus('bus');
        l_c_bus.add_equipment(c_card.create_card('card'));

        l_c_chassis.add_equipment(l_c_bus);
        l_c_chassis.add_equipment(c_floppy.create_floppy('3"'));

        // g_c_singleton:= c_singleton.f_c_singleton;
      end; // create_singleton_Click

end.


