// 004 u_c_equipment_8
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_equipment_8;
  interface
    uses Classes;

    type t_power= Double;
         t_currency= Double;

         c_equipment= class
                        _m_equipment_name: String;

                        Constructor _create_equipment(p_equipment_name: String);

                        function f_name: String;

                        function f_power: t_power; Virtual;
                        function f_net_price: t_currency; Virtual;
                        function f_discount_price: t_currency; Virtual;

                        procedure add_equipment(p_c_equipment: c_equipment); Virtual;
                        procedure remove_equipment(p_c_equipment: c_equipment); Virtual;
                        // function f_c_iterator: c_iterator; Virtual;

                        Destructor Destroy; Override;
                      end; // c_window

         c_composite_equipment= class(c_equipment)
                                  _m_c_equipment_list: tList;

                                  Constructor create_composite_equipment(p_equipment_name: String);

                                  function f_power: t_power; Override;
                                  function f_net_price: t_currency; Override;
                                  function f_discount_price: t_currency; Override;

                                  function f_equipent_count: Integer;
                                  function f_c_equipment(p_equipment_index: Integer): c_equipment;
                                  procedure add_equipment(p_c_equipment: c_equipment); Override;
                                  procedure remove_equipment(p_c_equipment: c_equipment); Override;
                                  // function f_c_iterator: c_iterator; Override;

                                  Destructor Destroy; Override;
                                end; // c_composite_equipment

  implementation

    // -- c_equipment

    Constructor c_equipment._create_equipment(p_equipment_name: String);
      begin
        Inherited Create;
        _m_equipment_name:= p_equipment_name;
      end; // _create_equipment

    function c_equipment.f_name: string;
      begin
      end; // f_name

    function c_equipment.f_power: t_power;
      begin
      end; // f_power

    function c_equipment.f_net_price: t_currency;
      begin
      end; // f_net_price

    function c_equipment.f_discount_price: t_currency;
      begin
      end; // f_discount_price

    procedure c_equipment.add_equipment(p_c_equipment: c_equipment);
      begin
      end; // add_equipment

    procedure c_equipment.remove_equipment(p_c_equipment: c_equipment);
      begin
      end; // remove_equipment

    Destructor c_equipment.Destroy;
      begin
        Inherited;
      end; // Destroy

    // -- c_composite_equipment

    Constructor c_composite_equipment.create_composite_equipment(p_equipment_name: String);
      begin
        Inherited _create_equipment(p_equipment_name);
      end; // create_composite_equipment

    function c_composite_equipment.f_power: t_power;
      begin
      end; // f_power

    function c_composite_equipment.f_net_price: t_currency;
      var l_equipment_index: Integer;
      begin
        Result:= 0;
        for l_equipment_index:= 0 to f_equipent_count- 1 do
          Result:= Result+ f_c_equipment(l_equipment_index).f_net_price;
      end; // f_net_price

    function c_composite_equipment.f_discount_price: t_currency;
      begin
      end; // f_discount_price

    function c_composite_equipment.f_equipent_count: Integer;
      begin
        Result:= _m_c_equipment_list.Count;
      end; // f_equipent_count

    function c_composite_equipment.f_c_equipment(p_equipment_index: Integer): c_equipment;
      begin
        Result:= c_equipment(_m_c_equipment_list[p_equipment_index]);
      end; // f_c_equipment

    procedure c_composite_equipment.add_equipment(p_c_equipment: c_equipment);
      begin
      end; // add_equipment

    procedure c_composite_equipment.remove_equipment(p_c_equipment: c_equipment);
      begin
      end; // remove_equipment

    Destructor c_composite_equipment.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_window
    end. // u_c_window
