// 004 u_c_equipment_kinds_8
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_equipment_kinds_8;
  interface
    uses u_c_equipment_8;

    type c_floppy= class(c_equipment)
                     Constructor create_floppy(p_equipment_name: String);

                     function f_power: t_power; Override;
                     function f_net_price: t_currency; Override;
                     function f_discount_price: t_currency; Override;

                     Destructor Destroy; Override;
                   end; // c_floppy

         c_card= class(c_equipment)
                   Constructor create_card(p_equipment_name: String);

                   function f_power: t_power; Override;
                   function f_net_price: t_currency; Override;
                   function f_discount_price: t_currency; Override;

                   Destructor Destroy; Override;
                 end; // c_card

         c_bus= class(c_composite_equipment)
                  Constructor create_bus(p_equipment_name: String);

                  function f_power: t_power; Override;
                  function f_net_price: t_currency; Override;
                  function f_discount_price: t_currency; Override;

                  Destructor Destroy; Override;
                end; // c_bus

         c_chassis= class(c_composite_equipment)
                      Constructor create_chassis(p_equipment_name: String);

                      function f_power: t_power; Override;
                      function f_net_price: t_currency; Override;
                      function f_discount_price: t_currency; Override;

                      Destructor Destroy; Override;
                    end; // c_chassis

         c_cabinet= class(c_composite_equipment)
                      Constructor create_cabinet(p_equipment_name: String);

                      function f_power: t_power; Override;
                      function f_net_price: t_currency; Override;
                      function f_discount_price: t_currency; Override;

                      Destructor Destroy; Override;
                    end; // c_cabinet

  implementation

    // -- c_floppy

    Constructor c_floppy.create_floppy(p_equipment_name: String);
      begin
        Inherited _create_equipment(p_equipment_name);
      end; // create_floppy

    function c_floppy.f_power: t_power;
      begin
      end; // f_power

    function c_floppy.f_net_price: t_currency;
      begin
      end; // f_net_price

    function c_floppy.f_discount_price: t_currency;
      begin
      end; // f_discount_price

    Destructor c_floppy.Destroy;
      begin
        Inherited;
      end; // Destroy

    // -- c_card

    Constructor c_card.create_card(p_equipment_name: String);
      begin
        Inherited _create_equipment(p_equipment_name);
      end; // create_card

    function c_card.f_power: t_power;
      begin
      end; // f_power

    function c_card.f_net_price: t_currency;
      begin
      end; // f_net_price

    function c_card.f_discount_price: t_currency;
      begin
      end; // f_discount_price

    Destructor c_card.Destroy;
      begin
        Inherited;
      end; // Destroy

    // -- c_bus

    Constructor c_bus.create_bus(p_equipment_name: String);
      begin
        Inherited create_composite_equipment(p_equipment_name);
      end; // create_bus

    function c_bus.f_power: t_power;
      begin
      end; // f_power

    function c_bus.f_net_price: t_currency;
      begin
      end; // f_net_price

    function c_bus.f_discount_price: t_currency;
      begin
      end; // f_discount_price

    Destructor c_bus.Destroy;
      begin
        Inherited;
      end; // Destroy

    // -- c_chassis

    Constructor c_chassis.create_chassis(p_equipment_name: String);
      begin
        Inherited create_composite_equipment(p_equipment_name);
      end; // create_chassis

    function c_chassis.f_power: t_power;
      begin
      end; // f_power

    function c_chassis.f_net_price: t_currency;
      begin
      end; // f_net_price

    function c_chassis.f_discount_price: t_currency;
      begin
      end; // f_discount_price

    Destructor c_chassis.Destroy;
      begin
        Inherited;
      end; // Destroy

    // -- c_cabinet

    Constructor c_cabinet.create_cabinet(p_equipment_name: String);
      begin
        Inherited create_composite_equipment(p_equipment_name);
      end; // create_cabinet

    function c_cabinet.f_power: t_power;
      begin
      end; // f_power

    function c_cabinet.f_net_price: t_currency;
      begin
      end; // f_net_price

    function c_cabinet.f_discount_price: t_currency;
      begin
      end; // f_discount_price

    Destructor c_cabinet.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_floppy
    end. // u_c_floppy
